testfunction=1;
switch testfunction
    case 1
      % y'=y^2-y^3
addpath('lambert')
funz='y^2-y^3';
f=inline(funz,'t','y');
solution=inline('1./(1+wapr((1/0.001-1)*exp(1/0.001-1-t))'')','t');
T0=0;
T=2/0.001;
y0=0.001;
end

M=4;
hhmeth=zeros(M+1,1);
labmeth=cell(M+1,1);
hherr=zeros(M,1);
laberr=cell(M,1);
hstep=zeros(M,1);
col='brgcmy';

methods=0;

%ode23

methods=methods+1;
methlab='ode23';
labmeth{1}=methlab;
labmeth{methods+1}=methlab;
laberr{methods}=methlab;
tic
[t,y]=ode23(f,[T0,T],y0);
tim=toc;
fprintf('%s: Nsteps: %i - CPU: %f\n',...
    methlab,length(t),tim)
ytrue=solution(t); ytrue=ytrue(:);
figure(1)
clf
set(gcf,'Name','Soluzioni')
subplot(2,1,1)
hhmeth(1)=plot(t,ytrue,'--k','LineWidth',2);
hold on
hhmeth(methods+1)=plot(t,y,col(methods));
subplot(2,1,2)
hherr(methods)=plot(t,y-ytrue,['-*' col(methods)]);
hold on
figure(2)
clf
set(gcf,'Name','Passi temporali')
hstep(methods)=plot(t(2:end),diff(t),col(methods));
hold on

%ode45

methods=methods+1;
methlab='ode45';
labmeth{1}=methlab;
labmeth{methods+1}=methlab;
laberr{methods}=methlab;
tic
[t,y]=ode45(f,[T0,T],y0);
tim=toc;
fprintf('%s: Nsteps: %i - CPU: %f\n',...
    methlab,length(t),tim)
ytrue=solution(t); ytrue=ytrue(:);
figure(1)
subplot(2,1,1)
hhmeth(methods+1)=plot(t,y,col(methods));
subplot(2,1,2)
hherr(methods)=plot(t,y-ytrue,['-*' col(methods)]);
figure(2)
hstep(methods)=plot(t(2:end),diff(t),col(methods));

%ode15s

methods=methods+1;
methlab='ode15s';
labmeth{1}=methlab;
labmeth{methods+1}=methlab;
laberr{methods}=methlab;
tic
[t,y]=ode15s(f,[T0,T],y0);
tim=toc;
fprintf('%s: Nsteps: %i - CPU: %f\n',...
    methlab,length(t),tim)
ytrue=solution(t); ytrue=ytrue(:);
figure(1)
subplot(2,1,1)
hhmeth(methods+1)=plot(t,y,col(methods));
subplot(2,1,2)
hherr(methods)=plot(t,y-ytrue,['-*' col(methods)]);
figure(2)
hstep(methods)=plot(t(2:end),diff(t),col(methods));

%ode23s

methods=methods+1;
methlab='ode23s';
labmeth{1}=methlab;
labmeth{methods+1}=methlab;
laberr{methods}=methlab;
tic
[t,y]=ode23s(f,[T0,T],y0);
tim=toc;
fprintf('%s: Nsteps: %i - CPU: %f\n',...
    methlab,length(t),tim)
ytrue=solution(t); ytrue=ytrue(:);
figure(1)
subplot(2,1,1)
hhmeth(methods+1)=plot(t,y,col(methods));
subplot(2,1,2)
hherr(methods)=plot(t,y-ytrue,['-*' col(methods)]);
figure(2)
hstep(methods)=plot(t(2:end),diff(t),col(methods));

% Fine metodi

figure(1)
subplot(2,1,1)
xlabel('t')
ylabel('y')
title(funz)
legend(hhmeth,labmeth,'Location','Best')

subplot(2,1,2)
xlabel('t')
ylabel('Errore')
legend(hherr,laberr,'Location','Best')

figure(2)
xlabel('t')
ylabel('\Delta t')
title('Passi temporali')
legend(hstep,laberr,'Location','Best')


